Reference Manual

Main Page | Namespace List | Class Hierarchy | Alphabetical List | Compound List | File List | Namespace Members | Compound Members | File Members

# Inti::Gtk::HandleBox Class Reference

A GtkHandleBox C++ wrapper class. More...

`#include <inti/gtk/handlebox.h>`

Inheritance diagram for Inti::Gtk::HandleBox:

List of all members.

## Public Member Functions

Constructors

- HandleBox (ShadowType shadow_type=SHADOW_OUT)
    Construct a new HandleBox with the specified shadow type drawn around the border.
- virtual ~HandleBox ()
    Destructor.

Accessors

- GtkHandleBox * gtk_handle_box () const
    Get a pointer to the GtkHandleBox structure.
- GtkHandleBoxClass * gtk_handle_box_class () const
    Get a pointer to the GtkHandleBoxClass structure.
- operator GtkHandleBox * () const
    Conversion operator; safely converts a HandleBox to a GtkHandleBox pointer.
- bool is_child_detached () const
    Returns true if the handlebox's child is detached.
- Gdk::Window * get_bin_window () const
    Gets the parent Gdk::Window for the child.
- Gdk::Window * get_float_window () const
    Gets the Gdk::Window for the floating window.
- ShadowType get_shadow_type () const
    Gets the type of shadow drawn around the handle box (see set_shadow_type()).
- PositionType get_handle_position () const
    Gets the handle position of the handle box (see set_handle_position()).
- PositionType get_snap_edge () const
    Gets the edge used for determining reattachment of the handle box (see set_snap_edge()).

Methods

- void set_shadow_type (ShadowType type)
    Sets the type of shadow to be drawn around the border of the handle box.
- void set_handle_position (PositionType position)
    Sets the side of the handlebox where the handle is drawn.
- void set_snap_edge (PositionType edge)
    Sets the snap edge of a handlebox.
- void unset_snap_edge ()
    Unsets the snap edge of a handlebox, in which case GTK+ will try to guess an appropriate value in the future.

Property Proxies

- const ShadowTypePropertyProxy prop_shadow_type ()
    Appearance of the shadow that surrounds the container (ShadowType : Read / Write).
- const HandlePositionPropertyProxy prop_handle_position ()
    Position of the handle relative to the child widget (PositionType : Read / Write).
- const SnapEdgePropertyProxy prop_snap_edge ()
    Side of the handlebox that's lined up with the docking point to dock the handlebox (PositionType : Read / Write).
- const SnapEdgeSetPropertyProxy prop_snap_edge_set ()
    Whether to use the value from the snap_edge property or a value derived from the handle position (bool : Read / Write).

Signals Proxies

- const ChildAttachedSignalProxy sig_child_attached ()
    Connect to the child_attached_signal; emitted when the contents of the handlebox are reattached to the main window.
- const ChildDetachedSignalProxy sig_child_detached ()
    Connect to the child_detached_signal; emitted when the contents of the handlebox are detached from the main window.

## Protected Member Functions

Constructors

- HandleBox (GtkHandleBox *handle_box, bool reference=false)
    Construct a new HandleBox from an existing GtkHandleBox.

Signal Handlers

- virtual void on_child_attached (Widget &child)
    Called when the contents of the handlebox are reattached to the main window.
- virtual void on_child_detached (Widget &child)
    Called when the contents of the handlebox are detached from the main window.

## Detailed Description

A GtkHandleBox C++ wrapper class.

The HandleBox widget allows a portion of a window to be "torn off". It is a bin widget which displays its child and a handle that the user can drag to tear off a separate window (the float window) containing the child widget. A thin ghost is drawn in the original location of the handlebox. By dragging the separate window back to its original location, it can be reattached. When reattaching, the ghost and float window, must be aligned along one of the edges, the snap edge. This either can be specified by the application programmer explicitely, or GTK+ will pick a reasonable default based on the handle position. To make detaching and reattaching the handlebox as minimally confusing as possible to the user, it is important to set the snap edge so that the snap edge does not move when the handlebox is deattached. For instance, if the handlebox is packed at the bottom of a VBox, then when the handlebox is detached, the bottom edge of the handlebox's allocation will remain fixed as the height of the handlebox shrinks, so the snap edge should be set to POS_BOTTOM.

## Constructor & Destructor Documentation

Inti::Gtk::HandleBox::HandleBox | ( | GtkHandleBox * | handle_box,
|  | bool | reference = false
| ) | `[explicit, protected]`

  | Construct a new HandleBox from an existing GtkHandleBox. Parameters:
  handle_box | A pointer to a GtkHandleBox.
  reference | Set false if the initial reference count is floating, set true if it's not.
The handle_box can be a newly created GtkHandleBox or an existing GtkHandleBox (see G::Object::Object).

Inti::Gtk::HandleBox::HandleBox | ( | ShadowType | shadow_type = SHADOW_OUT | ) | `[explicit]`

  | Construct a new HandleBox with the specified shadow type drawn around the border. Parameters:
  shadow_type | The shadow type.

## Member Function Documentation

virtual void Inti::Gtk::HandleBox::on_child_attached | ( | Widget & | child | ) | `[protected, virtual]`

  | Called when the contents of the handlebox are reattached to the main window. Parameters:
  child | The child widget of the handlebox.
The child argument provides no extra information and is here only for backwards compatibility.

virtual void Inti::Gtk::HandleBox::on_child_detached | ( | Widget & | child | ) | `[protected, virtual]`

  | Called when the contents of the handlebox are detached from the main window. Parameters:
  child | The child widget of the handlebox.
The child argument provides no extra information and is here only for backwards compatibility.

void Inti::Gtk::HandleBox::set_handle_position | ( | PositionType | position | ) |

  | Sets the side of the handlebox where the handle is drawn. Parameters:
  position | The side of the handlebox where the handle should be drawn.

void Inti::Gtk::HandleBox::set_shadow_type | ( | ShadowType | type | ) |

  | Sets the type of shadow to be drawn around the border of the handle box. Parameters:
  type | The shadow type.

void Inti::Gtk::HandleBox::set_snap_edge | ( | PositionType | edge | ) |

  | Sets the snap edge of a handlebox. Parameters:
  edge | The snap edge.
The snap edge is the edge of the detached child that must be aligned with the corresponding edge of the "ghost" left behind when the child was detached to reattach the torn-off window. Usually, the snap edge should be chosen so that it stays in the same place on the screen when the handlebox is torn off. If the snap edge is not set, then an appropriate value will be guessed from the handle position. If the handle position is POS_RIGHT or POS_LEFT, then the snap edge will be POS_TOP, otherwise it will be POS_LEFT.

The documentation for this class was generated from the following file:

- handlebox.h

Main Page - Footer